<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '../../plugins/contentful.js';
import { CONTENT_TYPES } from '../../common/content-types';
import { getPageMetadata } from '~/common/meta';
import { SolutionsHero as Hero } from '~/components/solutions/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';
import {
  ContactCards as Cards,
  ContactForms,
} from '~/components/company/index.vue';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  components: {
    Hero,
    Cards,
    ContactForms,
    NextStepAlt,
  },
  mixins: [FooterEditLinkMixin],
  nuxtI18n: false,
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'company/contact',
        include: 10,
      });
      const data = items[0].fields.pageContent;
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;
      const [cmsHero, cmsCards, cmsForm, cmsForm2] = data;

      const cardArray = cmsCards.fields.card.map((item) => {
        return {
          title: item.fields.title,
          description: item.fields.description,
          icon: {
            name: item.fields.iconName,
            variant: 'marketing',
            alt: item.fields.iconName,
          },
          href: item.fields.button.fields.externalUrl,
          data_ga_name: item.fields.button.fields.dataGaName,
          data_ga_location: item.fields.button.fields.dataGaLocation,
        };
      });

      const hero = {
        data: {
          title: cmsHero.fields.title,
          subtitle: cmsHero.fields.description,
          image: {
            image_url: cmsHero.fields.backgroundImage.fields.file.url,
            bordered: true,
            rectangular: true,
          },
        },
        name: 'hero',
      };

      const cards = {
        name: 'cards',
        data: {
          title: cmsCards.fields.header,
          column_size: 4,
          cards: cardArray,
        },
      };

      const contactForms = {
        data: {
          form1: {
            formId: cmsForm.fields.formId,
            form_header: cmsForm.fields.header,
            form_paragraph: cmsForm.fields.blurb,
            dataLayer: 'newsletter',
          },
          form2: {
            formId: cmsForm2.fields.formId,
            form_header: cmsForm2.fields.header,
            form_paragraph: cmsForm2.fields.blurb,
            dataLayer: 'security-notice',
          },
        },
        name: 'contact-forms',
      };

      const contact = {
        title: items[0].fields.seoMetadata[0].fields.title,
        description: items[0].fields.seoMetadata[0].fields.description,
        components: [hero, cards, contactForms],
      };

      return { contact, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).contact, this.$route.path);
  },
});
</script>

<template>
  <div>
    <SlpColumn>
      <component
        :is="component.name"
        v-for="component in contact.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpColumn>
    <NextStepAlt />
  </div>
</template>

<style lang="scss">
// Form also used on /the-source/
#mktoForm_1077 {
  grid-template-columns: 1fr;
  display: inline;
  box-shadow: none;
  padding: 0px;
}

#mktoForm_1102 {
  select {
    padding: 13px 16px;
    border-radius: 2px;
    appearance: none;
    background: url('/nuxt-images/icons/dropdown-chevron.svg') no-repeat 97%
      center;
    background-size: 9px;
    border: 1px solid #777 !important;
    border-radius: 4px;
    color: black !important;
    width: 100%;
    max-width: 100%;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
    box-sizing: border-box;

    @media (max-width: 768px) {
      font-size: 16px;
      padding: 10px 16px;
    }
  }
}
</style>
